//#line 2 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
// 
// File autogenerated for the sr_ronex_drivers package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __sr_ronex_drivers__GENERALIOCONFIG_H__
#define __sr_ronex_drivers__GENERALIOCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace sr_ronex_drivers
{
  class GeneralIOConfigStatics;
  
  class GeneralIOConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(GeneralIOConfig &config, const GeneralIOConfig &max, const GeneralIOConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const GeneralIOConfig &config1, const GeneralIOConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, GeneralIOConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const GeneralIOConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, GeneralIOConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const GeneralIOConfig &config) const = 0;
      virtual void getValue(const GeneralIOConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T GeneralIOConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (GeneralIOConfig::* field);

      virtual void clamp(GeneralIOConfig &config, const GeneralIOConfig &max, const GeneralIOConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const GeneralIOConfig &config1, const GeneralIOConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, GeneralIOConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const GeneralIOConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, GeneralIOConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const GeneralIOConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const GeneralIOConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, GeneralIOConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    template<class T, class PT>
    class GroupDescription : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string name, std::string type, int parent, int id, bool s, T PT::* f) : AbstractGroupDescription(name, type, parent, id, s), field(f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, GeneralIOConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<GeneralIOConfig::AbstractGroupDescriptionConstPtr> groups;
    };
    
class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(GeneralIOConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("pwm_clock_divider"==(*_i)->name){pwm_clock_divider = boost::any_cast<int>(val);}
        if("input_mode_0"==(*_i)->name){input_mode_0 = boost::any_cast<bool>(val);}
        if("input_mode_1"==(*_i)->name){input_mode_1 = boost::any_cast<bool>(val);}
        if("input_mode_2"==(*_i)->name){input_mode_2 = boost::any_cast<bool>(val);}
        if("input_mode_3"==(*_i)->name){input_mode_3 = boost::any_cast<bool>(val);}
        if("input_mode_4"==(*_i)->name){input_mode_4 = boost::any_cast<bool>(val);}
        if("input_mode_5"==(*_i)->name){input_mode_5 = boost::any_cast<bool>(val);}
        if("input_mode_6"==(*_i)->name){input_mode_6 = boost::any_cast<bool>(val);}
        if("input_mode_7"==(*_i)->name){input_mode_7 = boost::any_cast<bool>(val);}
        if("input_mode_8"==(*_i)->name){input_mode_8 = boost::any_cast<bool>(val);}
        if("input_mode_9"==(*_i)->name){input_mode_9 = boost::any_cast<bool>(val);}
        if("input_mode_10"==(*_i)->name){input_mode_10 = boost::any_cast<bool>(val);}
        if("input_mode_11"==(*_i)->name){input_mode_11 = boost::any_cast<bool>(val);}
        if("pwm_period_0"==(*_i)->name){pwm_period_0 = boost::any_cast<int>(val);}
        if("pwm_period_1"==(*_i)->name){pwm_period_1 = boost::any_cast<int>(val);}
        if("pwm_period_2"==(*_i)->name){pwm_period_2 = boost::any_cast<int>(val);}
        if("pwm_period_3"==(*_i)->name){pwm_period_3 = boost::any_cast<int>(val);}
        if("pwm_period_4"==(*_i)->name){pwm_period_4 = boost::any_cast<int>(val);}
        if("pwm_period_5"==(*_i)->name){pwm_period_5 = boost::any_cast<int>(val);}
      }
    }

    int pwm_clock_divider;
bool input_mode_0;
bool input_mode_1;
bool input_mode_2;
bool input_mode_3;
bool input_mode_4;
bool input_mode_5;
bool input_mode_6;
bool input_mode_7;
bool input_mode_8;
bool input_mode_9;
bool input_mode_10;
bool input_mode_11;
int pwm_period_0;
int pwm_period_1;
int pwm_period_2;
int pwm_period_3;
int pwm_period_4;
int pwm_period_5;

    bool state;
    std::string name;

    
}groups;



//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int pwm_clock_divider;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_3;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_4;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_5;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_6;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_7;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_8;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_9;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_10;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool input_mode_11;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int pwm_period_0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int pwm_period_1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int pwm_period_2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int pwm_period_3;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int pwm_period_4;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int pwm_period_5;
//#line 255 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("GeneralIOConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const GeneralIOConfig &__max__ = __getMax__();
      const GeneralIOConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const GeneralIOConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const GeneralIOConfig &__getDefault__();
    static const GeneralIOConfig &__getMax__();
    static const GeneralIOConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();
    
  private:
    static const GeneralIOConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void GeneralIOConfig::ParamDescription<std::string>::clamp(GeneralIOConfig &config, const GeneralIOConfig &max, const GeneralIOConfig &min) const
  {
    return;
  }

  class GeneralIOConfigStatics
  {
    friend class GeneralIOConfig;
    
    GeneralIOConfigStatics()
    {
GeneralIOConfig::GroupDescription<GeneralIOConfig::DEFAULT, GeneralIOConfig> Default("Default", "", 0, 0, true, &GeneralIOConfig::groups);
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pwm_clock_divider = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pwm_clock_divider = 65536;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pwm_clock_divider = 20;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_clock_divider", "int", 0, "The divider which is applied to the master clock (which runs at 64MHz).", "", &GeneralIOConfig::pwm_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_clock_divider", "int", 0, "The divider which is applied to the master clock (which runs at 64MHz).", "", &GeneralIOConfig::pwm_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_0", "bool", 0, "Digital Pin 0 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_0", "bool", 0, "Digital Pin 0 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_1", "bool", 0, "Digital Pin 1 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_1", "bool", 0, "Digital Pin 1 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_2", "bool", 0, "Digital Pin 2 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_2", "bool", 0, "Digital Pin 2 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_3", "bool", 0, "Digital Pin 3 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_3", "bool", 0, "Digital Pin 3 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_4 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_4 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_4 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_4", "bool", 0, "Digital Pin 4 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_4", "bool", 0, "Digital Pin 4 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_5 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_5 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_5 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_5", "bool", 0, "Digital Pin 5 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_5", "bool", 0, "Digital Pin 5 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_6 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_6 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_6 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_6", "bool", 0, "Digital Pin 6 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_6)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_6", "bool", 0, "Digital Pin 6 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_6)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_7 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_7 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_7 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_7", "bool", 0, "Digital Pin 7 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_7)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_7", "bool", 0, "Digital Pin 7 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_7)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_8 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_8 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_8 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_8", "bool", 0, "Digital Pin 8 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_8)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_8", "bool", 0, "Digital Pin 8 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_8)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_9 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_9 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_9 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_9", "bool", 0, "Digital Pin 9 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_9)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_9", "bool", 0, "Digital Pin 9 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_9)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_10 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_10 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_10 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_10", "bool", 0, "Digital Pin 10 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_10)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_10", "bool", 0, "Digital Pin 10 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_10)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.input_mode_11 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.input_mode_11 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.input_mode_11 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_11", "bool", 0, "Digital Pin 11 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_11)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<bool>("input_mode_11", "bool", 0, "Digital Pin 11 - True to use digital pins as inputs, false to use them as outputs.", "", &GeneralIOConfig::input_mode_11)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pwm_period_0 = 2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pwm_period_0 = 65536;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pwm_period_0 = 64000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_0", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_0", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pwm_period_1 = 2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pwm_period_1 = 65536;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pwm_period_1 = 64000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_1", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_1", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pwm_period_2 = 2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pwm_period_2 = 65536;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pwm_period_2 = 64000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_2", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_2", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pwm_period_3 = 2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pwm_period_3 = 65536;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pwm_period_3 = 64000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_3", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_3", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pwm_period_4 = 2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pwm_period_4 = 65536;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pwm_period_4 = 64000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_4", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_4", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pwm_period_5 = 2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pwm_period_5 = 65536;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pwm_period_5 = 64000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_5", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(GeneralIOConfig::AbstractParamDescriptionConstPtr(new GeneralIOConfig::ParamDescription<int>("pwm_period_5", "int", 0, "The PWM period for the given module.", "", &GeneralIOConfig::pwm_period_5)));
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(GeneralIOConfig::AbstractGroupDescriptionConstPtr(new GeneralIOConfig::GroupDescription<GeneralIOConfig::DEFAULT, GeneralIOConfig>(Default)));
//#line 390 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<GeneralIOConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__); 
    }
    std::vector<GeneralIOConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<GeneralIOConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    GeneralIOConfig __max__;
    GeneralIOConfig __min__;
    GeneralIOConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const GeneralIOConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static GeneralIOConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &GeneralIOConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const GeneralIOConfig &GeneralIOConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const GeneralIOConfig &GeneralIOConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const GeneralIOConfig &GeneralIOConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<GeneralIOConfig::AbstractParamDescriptionConstPtr> &GeneralIOConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<GeneralIOConfig::AbstractGroupDescriptionConstPtr> &GeneralIOConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const GeneralIOConfigStatics *GeneralIOConfig::__get_statics__()
  {
    const static GeneralIOConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = GeneralIOConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __GENERALIORECONFIGURATOR_H__
