//#line 2 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
// 
// File autogenerated for the sr_ronex_drivers package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __sr_ronex_drivers__SPICONFIG_H__
#define __sr_ronex_drivers__SPICONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace sr_ronex_drivers
{
  class SPIConfigStatics;
  
  class SPIConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(SPIConfig &config, const SPIConfig &max, const SPIConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const SPIConfig &config1, const SPIConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, SPIConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const SPIConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, SPIConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const SPIConfig &config) const = 0;
      virtual void getValue(const SPIConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T SPIConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (SPIConfig::* field);

      virtual void clamp(SPIConfig &config, const SPIConfig &max, const SPIConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const SPIConfig &config1, const SPIConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, SPIConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const SPIConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, SPIConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const SPIConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const SPIConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, SPIConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    template<class T, class PT>
    class GroupDescription : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string name, std::string type, int parent, int id, bool s, T PT::* f) : AbstractGroupDescription(name, type, parent, id, s), field(f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, SPIConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<SPIConfig::AbstractGroupDescriptionConstPtr> groups;
    };
    
class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(SPIConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("command_type"==(*_i)->name){command_type = boost::any_cast<int>(val);}
        if("pin_output_state_pre_DIO_0"==(*_i)->name){pin_output_state_pre_DIO_0 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_DIO_0"==(*_i)->name){pin_output_state_post_DIO_0 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_dir_DIO_0"==(*_i)->name){pin_output_state_pre_dir_DIO_0 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_dir_DIO_0"==(*_i)->name){pin_output_state_post_dir_DIO_0 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_DIO_1"==(*_i)->name){pin_output_state_pre_DIO_1 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_DIO_1"==(*_i)->name){pin_output_state_post_DIO_1 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_dir_DIO_1"==(*_i)->name){pin_output_state_pre_dir_DIO_1 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_dir_DIO_1"==(*_i)->name){pin_output_state_post_dir_DIO_1 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_DIO_2"==(*_i)->name){pin_output_state_pre_DIO_2 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_DIO_2"==(*_i)->name){pin_output_state_post_DIO_2 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_dir_DIO_2"==(*_i)->name){pin_output_state_pre_dir_DIO_2 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_dir_DIO_2"==(*_i)->name){pin_output_state_post_dir_DIO_2 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_DIO_3"==(*_i)->name){pin_output_state_pre_DIO_3 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_DIO_3"==(*_i)->name){pin_output_state_post_DIO_3 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_dir_DIO_3"==(*_i)->name){pin_output_state_pre_dir_DIO_3 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_dir_DIO_3"==(*_i)->name){pin_output_state_post_dir_DIO_3 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_DIO_4"==(*_i)->name){pin_output_state_pre_DIO_4 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_DIO_4"==(*_i)->name){pin_output_state_post_DIO_4 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_dir_DIO_4"==(*_i)->name){pin_output_state_pre_dir_DIO_4 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_dir_DIO_4"==(*_i)->name){pin_output_state_post_dir_DIO_4 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_DIO_5"==(*_i)->name){pin_output_state_pre_DIO_5 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_DIO_5"==(*_i)->name){pin_output_state_post_DIO_5 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_dir_DIO_5"==(*_i)->name){pin_output_state_pre_dir_DIO_5 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_dir_DIO_5"==(*_i)->name){pin_output_state_post_dir_DIO_5 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_CS_0"==(*_i)->name){pin_output_state_pre_CS_0 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_CS_0"==(*_i)->name){pin_output_state_post_CS_0 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_CS_1"==(*_i)->name){pin_output_state_pre_CS_1 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_CS_1"==(*_i)->name){pin_output_state_post_CS_1 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_CS_2"==(*_i)->name){pin_output_state_pre_CS_2 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_CS_2"==(*_i)->name){pin_output_state_post_CS_2 = boost::any_cast<bool>(val);}
        if("pin_output_state_pre_CS_3"==(*_i)->name){pin_output_state_pre_CS_3 = boost::any_cast<bool>(val);}
        if("pin_output_state_post_CS_3"==(*_i)->name){pin_output_state_post_CS_3 = boost::any_cast<bool>(val);}
        if("spi_0_clock_divider"==(*_i)->name){spi_0_clock_divider = boost::any_cast<int>(val);}
        if("spi_0_SPI_config"==(*_i)->name){spi_0_SPI_config = boost::any_cast<int>(val);}
        if("spi_0_inter_byte_gap"==(*_i)->name){spi_0_inter_byte_gap = boost::any_cast<int>(val);}
        if("spi_1_clock_divider"==(*_i)->name){spi_1_clock_divider = boost::any_cast<int>(val);}
        if("spi_1_SPI_config"==(*_i)->name){spi_1_SPI_config = boost::any_cast<int>(val);}
        if("spi_1_inter_byte_gap"==(*_i)->name){spi_1_inter_byte_gap = boost::any_cast<int>(val);}
        if("spi_2_clock_divider"==(*_i)->name){spi_2_clock_divider = boost::any_cast<int>(val);}
        if("spi_2_SPI_config"==(*_i)->name){spi_2_SPI_config = boost::any_cast<int>(val);}
        if("spi_2_inter_byte_gap"==(*_i)->name){spi_2_inter_byte_gap = boost::any_cast<int>(val);}
        if("spi_3_clock_divider"==(*_i)->name){spi_3_clock_divider = boost::any_cast<int>(val);}
        if("spi_3_SPI_config"==(*_i)->name){spi_3_SPI_config = boost::any_cast<int>(val);}
        if("spi_3_inter_byte_gap"==(*_i)->name){spi_3_inter_byte_gap = boost::any_cast<int>(val);}
      }
    }

    int command_type;
bool pin_output_state_pre_DIO_0;
bool pin_output_state_post_DIO_0;
bool pin_output_state_pre_dir_DIO_0;
bool pin_output_state_post_dir_DIO_0;
bool pin_output_state_pre_DIO_1;
bool pin_output_state_post_DIO_1;
bool pin_output_state_pre_dir_DIO_1;
bool pin_output_state_post_dir_DIO_1;
bool pin_output_state_pre_DIO_2;
bool pin_output_state_post_DIO_2;
bool pin_output_state_pre_dir_DIO_2;
bool pin_output_state_post_dir_DIO_2;
bool pin_output_state_pre_DIO_3;
bool pin_output_state_post_DIO_3;
bool pin_output_state_pre_dir_DIO_3;
bool pin_output_state_post_dir_DIO_3;
bool pin_output_state_pre_DIO_4;
bool pin_output_state_post_DIO_4;
bool pin_output_state_pre_dir_DIO_4;
bool pin_output_state_post_dir_DIO_4;
bool pin_output_state_pre_DIO_5;
bool pin_output_state_post_DIO_5;
bool pin_output_state_pre_dir_DIO_5;
bool pin_output_state_post_dir_DIO_5;
bool pin_output_state_pre_CS_0;
bool pin_output_state_post_CS_0;
bool pin_output_state_pre_CS_1;
bool pin_output_state_post_CS_1;
bool pin_output_state_pre_CS_2;
bool pin_output_state_post_CS_2;
bool pin_output_state_pre_CS_3;
bool pin_output_state_post_CS_3;
int spi_0_clock_divider;
int spi_0_SPI_config;
int spi_0_inter_byte_gap;
int spi_1_clock_divider;
int spi_1_SPI_config;
int spi_1_inter_byte_gap;
int spi_2_clock_divider;
int spi_2_SPI_config;
int spi_2_inter_byte_gap;
int spi_3_clock_divider;
int spi_3_SPI_config;
int spi_3_inter_byte_gap;

    bool state;
    std::string name;

    
}groups;



//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int command_type;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_DIO_0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_DIO_0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_dir_DIO_0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_dir_DIO_0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_DIO_1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_DIO_1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_dir_DIO_1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_dir_DIO_1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_DIO_2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_DIO_2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_dir_DIO_2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_dir_DIO_2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_DIO_3;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_DIO_3;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_dir_DIO_3;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_dir_DIO_3;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_DIO_4;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_DIO_4;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_dir_DIO_4;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_dir_DIO_4;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_DIO_5;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_DIO_5;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_dir_DIO_5;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_dir_DIO_5;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_CS_0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_CS_0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_CS_1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_CS_1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_CS_2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_CS_2;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_pre_CS_3;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool pin_output_state_post_CS_3;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_0_clock_divider;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_0_SPI_config;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_0_inter_byte_gap;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_1_clock_divider;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_1_SPI_config;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_1_inter_byte_gap;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_2_clock_divider;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_2_SPI_config;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_2_inter_byte_gap;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_3_clock_divider;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_3_SPI_config;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int spi_3_inter_byte_gap;
//#line 255 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("SPIConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const SPIConfig &__max__ = __getMax__();
      const SPIConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const SPIConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const SPIConfig &__getDefault__();
    static const SPIConfig &__getMax__();
    static const SPIConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();
    
  private:
    static const SPIConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void SPIConfig::ParamDescription<std::string>::clamp(SPIConfig &config, const SPIConfig &max, const SPIConfig &min) const
  {
    return;
  }

  class SPIConfigStatics
  {
    friend class SPIConfig;
    
    SPIConfigStatics()
    {
SPIConfig::GroupDescription<SPIConfig::DEFAULT, SPIConfig> Default("Default", "", 0, 0, true, &SPIConfig::groups);
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.command_type = -2147483648;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.command_type = 2147483647;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.command_type = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("command_type", "int", 0, "The command type to be sent.", "{'enum_description': 'Command Types', 'enum': [{'srcline': 9, 'description': 'The command for normal operation', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Normal'}, {'srcline': 10, 'description': 'The command to request the config', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'Config'}]}", &SPIConfig::command_type)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("command_type", "int", 0, "The command type to be sent.", "{'enum_description': 'Command Types', 'enum': [{'srcline': 9, 'description': 'The command for normal operation', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Normal'}, {'srcline': 10, 'description': 'The command to request the config', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'Config'}]}", &SPIConfig::command_type)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_DIO_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_DIO_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_DIO_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_0", "bool", 0, "The pre state pin for DIO 0", "", &SPIConfig::pin_output_state_pre_DIO_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_0", "bool", 0, "The pre state pin for DIO 0", "", &SPIConfig::pin_output_state_pre_DIO_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_DIO_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_DIO_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_DIO_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_0", "bool", 0, "The post state pin for DIO 0", "", &SPIConfig::pin_output_state_post_DIO_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_0", "bool", 0, "The post state pin for DIO 0", "", &SPIConfig::pin_output_state_post_DIO_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_dir_DIO_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_dir_DIO_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_dir_DIO_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_0", "bool", 0, "The pre direction pin for DIO 0", "", &SPIConfig::pin_output_state_pre_dir_DIO_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_0", "bool", 0, "The pre direction pin for DIO 0", "", &SPIConfig::pin_output_state_pre_dir_DIO_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_dir_DIO_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_dir_DIO_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_dir_DIO_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_0", "bool", 0, "The post direction pin for DIO 0", "", &SPIConfig::pin_output_state_post_dir_DIO_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_0", "bool", 0, "The post direction pin for DIO 0", "", &SPIConfig::pin_output_state_post_dir_DIO_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_DIO_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_DIO_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_DIO_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_1", "bool", 0, "The pre state pin for DIO 1", "", &SPIConfig::pin_output_state_pre_DIO_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_1", "bool", 0, "The pre state pin for DIO 1", "", &SPIConfig::pin_output_state_pre_DIO_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_DIO_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_DIO_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_DIO_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_1", "bool", 0, "The post state pin for DIO 1", "", &SPIConfig::pin_output_state_post_DIO_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_1", "bool", 0, "The post state pin for DIO 1", "", &SPIConfig::pin_output_state_post_DIO_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_dir_DIO_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_dir_DIO_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_dir_DIO_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_1", "bool", 0, "The pre direction pin for DIO 1", "", &SPIConfig::pin_output_state_pre_dir_DIO_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_1", "bool", 0, "The pre direction pin for DIO 1", "", &SPIConfig::pin_output_state_pre_dir_DIO_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_dir_DIO_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_dir_DIO_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_dir_DIO_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_1", "bool", 0, "The post direction pin for DIO 1", "", &SPIConfig::pin_output_state_post_dir_DIO_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_1", "bool", 0, "The post direction pin for DIO 1", "", &SPIConfig::pin_output_state_post_dir_DIO_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_DIO_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_DIO_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_DIO_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_2", "bool", 0, "The pre state pin for DIO 2", "", &SPIConfig::pin_output_state_pre_DIO_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_2", "bool", 0, "The pre state pin for DIO 2", "", &SPIConfig::pin_output_state_pre_DIO_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_DIO_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_DIO_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_DIO_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_2", "bool", 0, "The post state pin for DIO 2", "", &SPIConfig::pin_output_state_post_DIO_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_2", "bool", 0, "The post state pin for DIO 2", "", &SPIConfig::pin_output_state_post_DIO_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_dir_DIO_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_dir_DIO_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_dir_DIO_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_2", "bool", 0, "The pre direction pin for DIO 2", "", &SPIConfig::pin_output_state_pre_dir_DIO_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_2", "bool", 0, "The pre direction pin for DIO 2", "", &SPIConfig::pin_output_state_pre_dir_DIO_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_dir_DIO_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_dir_DIO_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_dir_DIO_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_2", "bool", 0, "The post direction pin for DIO 2", "", &SPIConfig::pin_output_state_post_dir_DIO_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_2", "bool", 0, "The post direction pin for DIO 2", "", &SPIConfig::pin_output_state_post_dir_DIO_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_DIO_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_DIO_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_DIO_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_3", "bool", 0, "The pre state pin for DIO 3", "", &SPIConfig::pin_output_state_pre_DIO_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_3", "bool", 0, "The pre state pin for DIO 3", "", &SPIConfig::pin_output_state_pre_DIO_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_DIO_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_DIO_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_DIO_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_3", "bool", 0, "The post state pin for DIO 3", "", &SPIConfig::pin_output_state_post_DIO_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_3", "bool", 0, "The post state pin for DIO 3", "", &SPIConfig::pin_output_state_post_DIO_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_dir_DIO_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_dir_DIO_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_dir_DIO_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_3", "bool", 0, "The pre direction pin for DIO 3", "", &SPIConfig::pin_output_state_pre_dir_DIO_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_3", "bool", 0, "The pre direction pin for DIO 3", "", &SPIConfig::pin_output_state_pre_dir_DIO_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_dir_DIO_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_dir_DIO_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_dir_DIO_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_3", "bool", 0, "The post direction pin for DIO 3", "", &SPIConfig::pin_output_state_post_dir_DIO_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_3", "bool", 0, "The post direction pin for DIO 3", "", &SPIConfig::pin_output_state_post_dir_DIO_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_DIO_4 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_DIO_4 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_DIO_4 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_4", "bool", 0, "The pre state pin for DIO 4", "", &SPIConfig::pin_output_state_pre_DIO_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_4", "bool", 0, "The pre state pin for DIO 4", "", &SPIConfig::pin_output_state_pre_DIO_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_DIO_4 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_DIO_4 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_DIO_4 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_4", "bool", 0, "The post state pin for DIO 4", "", &SPIConfig::pin_output_state_post_DIO_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_4", "bool", 0, "The post state pin for DIO 4", "", &SPIConfig::pin_output_state_post_DIO_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_dir_DIO_4 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_dir_DIO_4 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_dir_DIO_4 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_4", "bool", 0, "The pre direction pin for DIO 4", "", &SPIConfig::pin_output_state_pre_dir_DIO_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_4", "bool", 0, "The pre direction pin for DIO 4", "", &SPIConfig::pin_output_state_pre_dir_DIO_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_dir_DIO_4 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_dir_DIO_4 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_dir_DIO_4 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_4", "bool", 0, "The post direction pin for DIO 4", "", &SPIConfig::pin_output_state_post_dir_DIO_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_4", "bool", 0, "The post direction pin for DIO 4", "", &SPIConfig::pin_output_state_post_dir_DIO_4)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_DIO_5 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_DIO_5 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_DIO_5 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_5", "bool", 0, "The pre state pin for DIO 5", "", &SPIConfig::pin_output_state_pre_DIO_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_DIO_5", "bool", 0, "The pre state pin for DIO 5", "", &SPIConfig::pin_output_state_pre_DIO_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_DIO_5 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_DIO_5 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_DIO_5 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_5", "bool", 0, "The post state pin for DIO 5", "", &SPIConfig::pin_output_state_post_DIO_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_DIO_5", "bool", 0, "The post state pin for DIO 5", "", &SPIConfig::pin_output_state_post_DIO_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_dir_DIO_5 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_dir_DIO_5 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_dir_DIO_5 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_5", "bool", 0, "The pre direction pin for DIO 5", "", &SPIConfig::pin_output_state_pre_dir_DIO_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_dir_DIO_5", "bool", 0, "The pre direction pin for DIO 5", "", &SPIConfig::pin_output_state_pre_dir_DIO_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_dir_DIO_5 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_dir_DIO_5 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_dir_DIO_5 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_5", "bool", 0, "The post direction pin for DIO 5", "", &SPIConfig::pin_output_state_post_dir_DIO_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_dir_DIO_5", "bool", 0, "The post direction pin for DIO 5", "", &SPIConfig::pin_output_state_post_dir_DIO_5)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_CS_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_CS_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_CS_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_CS_0", "bool", 0, "The pre state pin for spi CS 0", "", &SPIConfig::pin_output_state_pre_CS_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_CS_0", "bool", 0, "The pre state pin for spi CS 0", "", &SPIConfig::pin_output_state_pre_CS_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_CS_0 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_CS_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_CS_0 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_CS_0", "bool", 0, "The post state pin for spi CS 0", "", &SPIConfig::pin_output_state_post_CS_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_CS_0", "bool", 0, "The post state pin for spi CS 0", "", &SPIConfig::pin_output_state_post_CS_0)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_CS_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_CS_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_CS_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_CS_1", "bool", 0, "The pre state pin for spi CS 1", "", &SPIConfig::pin_output_state_pre_CS_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_CS_1", "bool", 0, "The pre state pin for spi CS 1", "", &SPIConfig::pin_output_state_pre_CS_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_CS_1 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_CS_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_CS_1 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_CS_1", "bool", 0, "The post state pin for spi CS 1", "", &SPIConfig::pin_output_state_post_CS_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_CS_1", "bool", 0, "The post state pin for spi CS 1", "", &SPIConfig::pin_output_state_post_CS_1)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_CS_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_CS_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_CS_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_CS_2", "bool", 0, "The pre state pin for spi CS 2", "", &SPIConfig::pin_output_state_pre_CS_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_CS_2", "bool", 0, "The pre state pin for spi CS 2", "", &SPIConfig::pin_output_state_pre_CS_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_CS_2 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_CS_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_CS_2 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_CS_2", "bool", 0, "The post state pin for spi CS 2", "", &SPIConfig::pin_output_state_post_CS_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_CS_2", "bool", 0, "The post state pin for spi CS 2", "", &SPIConfig::pin_output_state_post_CS_2)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_pre_CS_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_pre_CS_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_pre_CS_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_CS_3", "bool", 0, "The pre state pin for spi CS 3", "", &SPIConfig::pin_output_state_pre_CS_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_pre_CS_3", "bool", 0, "The pre state pin for spi CS 3", "", &SPIConfig::pin_output_state_pre_CS_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pin_output_state_post_CS_3 = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pin_output_state_post_CS_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pin_output_state_post_CS_3 = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_CS_3", "bool", 0, "The post state pin for spi CS 3", "", &SPIConfig::pin_output_state_post_CS_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<bool>("pin_output_state_post_CS_3", "bool", 0, "The post state pin for spi CS 3", "", &SPIConfig::pin_output_state_post_CS_3)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_0_clock_divider = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_0_clock_divider = 65535;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_0_clock_divider = 16;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_0_clock_divider", "int", 0, "The Clock Divider - SPI[0]", "", &SPIConfig::spi_0_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_0_clock_divider", "int", 0, "The Clock Divider - SPI[0]", "", &SPIConfig::spi_0_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_0_SPI_config = -2147483648;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_0_SPI_config = 2147483647;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_0_SPI_config = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_0_SPI_config", "int", 0, "The SPI Config - SPI[0]", "{'enum_description': 'The different SPI modes.', 'enum': [{'srcline': 59, 'description': 'Default mode', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MODE_00'}, {'srcline': 60, 'description': 'SPI mode 01', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MODE_01'}, {'srcline': 61, 'description': 'SPI mode 10', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MODE_10'}, {'srcline': 62, 'description': 'SPI mode 11', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MODE_11'}, {'srcline': 63, 'description': 'SPI input trigger NONE', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_NONE'}, {'srcline': 64, 'description': 'SPI input trigger D0', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D0'}, {'srcline': 65, 'description': 'SPI input trigger D1', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 8, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D1'}, {'srcline': 66, 'description': 'SPI input trigger D2', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 12, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D2'}, {'srcline': 67, 'description': 'SPI input trigger D3', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 16, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D3'}, {'srcline': 68, 'description': 'SPI input trigger D4', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 20, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D4'}, {'srcline': 69, 'description': 'SPI input trigger D5', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 24, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D5'}, {'srcline': 70, 'description': 'SPI MOSI SOMI different pin', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MOSI_SOMI_DIFFERENT_PIN'}, {'srcline': 71, 'description': 'SPI MOSI SOMI same pin', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 32, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MOSI_SOMI_SAME_PIN'}]}", &SPIConfig::spi_0_SPI_config)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_0_SPI_config", "int", 0, "The SPI Config - SPI[0]", "{'enum_description': 'The different SPI modes.', 'enum': [{'srcline': 59, 'description': 'Default mode', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MODE_00'}, {'srcline': 60, 'description': 'SPI mode 01', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MODE_01'}, {'srcline': 61, 'description': 'SPI mode 10', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MODE_10'}, {'srcline': 62, 'description': 'SPI mode 11', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MODE_11'}, {'srcline': 63, 'description': 'SPI input trigger NONE', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_NONE'}, {'srcline': 64, 'description': 'SPI input trigger D0', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D0'}, {'srcline': 65, 'description': 'SPI input trigger D1', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 8, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D1'}, {'srcline': 66, 'description': 'SPI input trigger D2', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 12, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D2'}, {'srcline': 67, 'description': 'SPI input trigger D3', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 16, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D3'}, {'srcline': 68, 'description': 'SPI input trigger D4', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 20, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D4'}, {'srcline': 69, 'description': 'SPI input trigger D5', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 24, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_INPUT_TRIGGER_D5'}, {'srcline': 70, 'description': 'SPI MOSI SOMI different pin', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MOSI_SOMI_DIFFERENT_PIN'}, {'srcline': 71, 'description': 'SPI MOSI SOMI same pin', 'srcfile': '/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg', 'cconsttype': 'const int', 'value': 32, 'ctype': 'int', 'type': 'int', 'name': 'SPI_CONFIG_MOSI_SOMI_SAME_PIN'}]}", &SPIConfig::spi_0_SPI_config)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_0_inter_byte_gap = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_0_inter_byte_gap = 255;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_0_inter_byte_gap = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_0_inter_byte_gap", "int", 0, "The Inter Byte Gap - SPI[0]", "", &SPIConfig::spi_0_inter_byte_gap)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_0_inter_byte_gap", "int", 0, "The Inter Byte Gap - SPI[0]", "", &SPIConfig::spi_0_inter_byte_gap)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_1_clock_divider = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_1_clock_divider = 65535;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_1_clock_divider = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_1_clock_divider", "int", 0, "The Clock Divider - SPI[1]", "", &SPIConfig::spi_1_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_1_clock_divider", "int", 0, "The Clock Divider - SPI[1]", "", &SPIConfig::spi_1_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_1_SPI_config = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_1_SPI_config = 65535;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_1_SPI_config = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_1_SPI_config", "int", 0, "The SPI Config - SPI[1]", "", &SPIConfig::spi_1_SPI_config)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_1_SPI_config", "int", 0, "The SPI Config - SPI[1]", "", &SPIConfig::spi_1_SPI_config)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_1_inter_byte_gap = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_1_inter_byte_gap = 255;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_1_inter_byte_gap = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_1_inter_byte_gap", "int", 0, "The Inter Byte Gap - SPI[1]", "", &SPIConfig::spi_1_inter_byte_gap)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_1_inter_byte_gap", "int", 0, "The Inter Byte Gap - SPI[1]", "", &SPIConfig::spi_1_inter_byte_gap)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_2_clock_divider = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_2_clock_divider = 65535;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_2_clock_divider = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_2_clock_divider", "int", 0, "The Clock Divider - SPI[2]", "", &SPIConfig::spi_2_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_2_clock_divider", "int", 0, "The Clock Divider - SPI[2]", "", &SPIConfig::spi_2_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_2_SPI_config = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_2_SPI_config = 65535;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_2_SPI_config = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_2_SPI_config", "int", 0, "The SPI Config - SPI[2]", "", &SPIConfig::spi_2_SPI_config)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_2_SPI_config", "int", 0, "The SPI Config - SPI[2]", "", &SPIConfig::spi_2_SPI_config)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_2_inter_byte_gap = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_2_inter_byte_gap = 255;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_2_inter_byte_gap = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_2_inter_byte_gap", "int", 0, "The Inter Byte Gap - SPI[2]", "", &SPIConfig::spi_2_inter_byte_gap)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_2_inter_byte_gap", "int", 0, "The Inter Byte Gap - SPI[2]", "", &SPIConfig::spi_2_inter_byte_gap)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_3_clock_divider = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_3_clock_divider = 65535;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_3_clock_divider = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_3_clock_divider", "int", 0, "The Clock Divider - SPI[3]", "", &SPIConfig::spi_3_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_3_clock_divider", "int", 0, "The Clock Divider - SPI[3]", "", &SPIConfig::spi_3_clock_divider)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_3_SPI_config = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_3_SPI_config = 65535;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_3_SPI_config = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_3_SPI_config", "int", 0, "The SPI Config - SPI[3]", "", &SPIConfig::spi_3_SPI_config)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_3_SPI_config", "int", 0, "The SPI Config - SPI[3]", "", &SPIConfig::spi_3_SPI_config)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spi_3_inter_byte_gap = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spi_3_inter_byte_gap = 255;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spi_3_inter_byte_gap = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_3_inter_byte_gap", "int", 0, "The Inter Byte Gap - SPI[3]", "", &SPIConfig::spi_3_inter_byte_gap)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SPIConfig::AbstractParamDescriptionConstPtr(new SPIConfig::ParamDescription<int>("spi_3_inter_byte_gap", "int", 0, "The Inter Byte Gap - SPI[3]", "", &SPIConfig::spi_3_inter_byte_gap)));
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(SPIConfig::AbstractGroupDescriptionConstPtr(new SPIConfig::GroupDescription<SPIConfig::DEFAULT, SPIConfig>(Default)));
//#line 390 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<SPIConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__); 
    }
    std::vector<SPIConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<SPIConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    SPIConfig __max__;
    SPIConfig __min__;
    SPIConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const SPIConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static SPIConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &SPIConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const SPIConfig &SPIConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const SPIConfig &SPIConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const SPIConfig &SPIConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<SPIConfig::AbstractParamDescriptionConstPtr> &SPIConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<SPIConfig::AbstractGroupDescriptionConstPtr> &SPIConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const SPIConfigStatics *SPIConfig::__get_statics__()
  {
    const static SPIConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = SPIConfigStatics::get_instance();
    
    return statics;
  }

//#line 9 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_Normal = 1;
//#line 10 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_Config = 2;
//#line 59 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_MODE_00 = 0;
//#line 60 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_MODE_01 = 1;
//#line 61 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_MODE_10 = 2;
//#line 62 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_MODE_11 = 3;
//#line 63 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_INPUT_TRIGGER_NONE = 0;
//#line 64 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_INPUT_TRIGGER_D0 = 4;
//#line 65 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_INPUT_TRIGGER_D1 = 8;
//#line 66 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_INPUT_TRIGGER_D2 = 12;
//#line 67 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_INPUT_TRIGGER_D3 = 16;
//#line 68 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_INPUT_TRIGGER_D4 = 20;
//#line 69 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_INPUT_TRIGGER_D5 = 24;
//#line 70 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_MOSI_SOMI_DIFFERENT_PIN = 0;
//#line 71 "/tmp/buildd/ros-hydro-sr-ronex-drivers-0.9.14-2raring-20150809-0226/cfg/SPI.cfg"
      const int SPI_SPI_CONFIG_MOSI_SOMI_SAME_PIN = 32;
}

#endif // __SPIRECONFIGURATOR_H__
